** lambda =0.4+0.2t for t<1 ***;
** lambda =0.6+0.3t for t<1 ***;
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=1000000;
%let seed=200;


data exp;
mean= 1.05;
adj = (1/&kappa +1)/(1/&kappa+0.5);
mean=mean*adj;
kappa= 1/(1/&kappa +1);
var= (kappa * mean +1)*mean;
proc print;
title "med1: actual mean / variance of number of events";
run;

data med1;
 u= 1.05;adj = (1/&kappa +1)/(1/&kappa+0.5);
 u=u*adj;
 kappa= 1/(1/&kappa +1);
do i=1 to &nsim;
 ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
 ** variarance alpha*beta*beta;
  v= kappa * rangam(&seed,1/kappa);
  n = RAND('POISSON',v*u);
  nnn=n; 
  if nnn>3 then nnn=4;
 output;
end;
run;

proc means data=med1 n mean std var;
var n;
run;

proc freq data=med1;
table nnn;
run;



data med1_2 (keep= i n t);
set med1;
if n=0 then output;
else do;
do j=1 to n;
 unif =uniform(&seed *2)*1.05+0.75;
 t = (sqrt(0.36+0.6 *unif)-0.6)/0.3;
 output;
 end;
end;
proc sort; by i t;
run;

data med1_3;
retain order;
set med1_2;
by i;
if first.i then order=1;
else order=order+1;
run;

data t1;
set med1_3;
if order=1;
proc means n mean std var;
var t;
title "med1: mean / variance of first event time";
run;

data t2;
set med1_3;
if order=2;
proc means n mean std var;
var t;
title "med1: mean / variance of second event time";
run;

data t3;
set med1_3;
if order=3;
proc means n mean std var;
var t;
title "med1: mean / variance of third event time";
run;
