** lambda =0.5exp(0.5t) for t<1 ***;
** lambda =0.75*exp(0.5t) for t in (1,2];
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=10000000;
%let seed=200;
%let beta=0.5;
%let alpha=0.5;

data a;
alpha=&alpha;
beta=&beta;
a=exp(beta)-1;
a1=a*alpha/beta;
b=exp(2*beta)-exp(beta);
b1=b*alpha*1.5/beta;
sig=log(&kappa+1);
mid = -sig/2;
sig=sqrt(sig);


mean =a1+b1;
var = mean +(&kappa) *mean*mean;
call symput('u1',a1);
call symput('u2',b1);
call symput('mid',mid);
call symput('sig', sig);

proc print;
run;


data med1;
do i=1 to &nsim;
  temp= 0; U=1;kkk=0;
  do until (U<temp);
   v =  rangam(&seed,2)/(&u1);
   U=uniform(&seed);
   kkk=kkk+1;
   y=log(v);
   temp = exp(-(y+1.5*&sig*&sig)**2/(2*&sig*&sig));
  end;
  n = RAND('POISSON',v*(&u2)); nnn=n; if nnn>3 then nnn=4;
  output;
end;

run;

proc means data=med1 mean std var;
var n kkk v;
run;

proc freq data=med1;
table nnn;
run;



data med1_2 (keep= i n t);
set med1;
if n=0 then output;
else do;
do j=1 to n;
 unif =uniform(&seed *2)*(&u2);
 t= log(unif*(&beta/&alpha/1.5)+exp(&beta))/(&beta);
 output;
 end;
end;
proc sort; by i t;
run;

data med1_3;
retain order;
set med1_2;
by i;
if first.i then order=1;
else order=order+1;
run;

data t1;
set med1_3;
if order=1;
proc means  mean std var;
var t;
title "med1: mean / variance of first event time";
run;

data t2;
set med1_3;
if order=2;
proc means  mean std var;
var t;
title "med1: mean / variance of second event time";
run;

data t3;
set med1_3;
if order=3;
proc means  mean std var;
var t;
title "med1: mean / variance of third event time";
run;
